package com.warewms.common.utils;

import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: andy.qu
 * Date: 2019/11/13
 */
public class QueryParam<T> extends LinkedHashMap<String,Object> {
    private static final long serialVersionUID = 1L;

    /**
     * 当前页码
     */
    private int currPage = 1;
    /**
     * 每页条数
     */
    private int limit = 10;

    private Set<String> paramMap = new HashSet<String>(){{
        add("page");
        add("limit");
        add("t");
    }};

    public QueryParam(Map<String, Object> params){

        for (String key : params.keySet()) {
            if(!paramMap.contains(key)){
                this.put(key,params.get(key));
            }
        }

        //分页参数
        if(params.get("page") != null){
            currPage = Integer.parseInt((String)params.get("page"));
        }
        if(params.get("limit") != null){
            limit = Integer.parseInt((String)params.get("limit"));
        }

    }

    public int getCurrPage() {
        return currPage;
    }

    public int getLimit() {
        return limit;
    }
}