package com.warewms.controller;

import com.warewms.common.utils.R;
import com.warewms.entity.erp.ErpBarCodeList;
import com.warewms.entity.erp.ErpOrderList;
import com.warewms.service.impl.ErpSyncServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Controller
@RequestMapping("/erp/erpWriteData")
@Slf4j
public class ErpWriteBackController {

    @Autowired
    private ErpSyncServiceImpl erpSyncService;

    @ResponseBody
    @PostMapping("erpSync")
    public R erpSync(){
        erpSyncService.erpSync();
        return R.ok();
    }

    /**
     * 中间表写入数据（叉车扫描条码记录表）
     */
    @ResponseBody
    @PostMapping("writeData")
    public R writeData(@RequestParam List<ErpBarCodeList> erpBarCodeListList){
        erpSyncService.writeBack(erpBarCodeListList);
        return R.ok();
    }

    /**
     * 中间表修改数据（需求单扫描状态修改）
     */
    @ResponseBody
    @PostMapping("updaOrderStatus")
    public R updaOrderStatus(@RequestParam ErpOrderList erpOrderList){
        erpSyncService.updaErpStatus(erpOrderList);
        return R.ok();
    }
}
