package com.warewms.thread;

import com.warewms.common.utils.SpringContextUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;

import javax.xml.bind.DatatypeConverter;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.*;

@Slf4j
public class SocketServerThread implements Runnable{

    public static final String startBox = "3A02650201016B2424";
    private static final String closeBox = "3A02650201006A2424";


    private static final String CHARSET = "UTF-8";
    List<Socket> sockets = new ArrayList<>();
    ServerSocket server = null;

    public SocketServerThread() {
        try {
            server = new ServerSocket(8899);
            System.out.println("Socket服务启动成功~");
        } catch (IOException e) {
            System.out.println("初始化Socket服务异常:\n");
            log.error(e.getMessage());
        }
    }

    @Override
    public void run() {
        try {
            while (true) {
                // 建立socket接口,accept方法等到用户连接才会继续执行
                log.info("当前连接数：" + sockets.size());
                Socket socket = server.accept();
                socket.setKeepAlive(true);
                // 在服务器显示连接的电脑
                String message = socket.getInetAddress().getHostAddress();
                System.out.println("客户端：" + message + "已连接~");
                // 向客户端发送信息
                //SendMessageToClient(message);
                new Timer().schedule(new TimerTask() {// 定时任务
                    @Override
                    public void run() {
                        try {
                            socket.sendUrgentData(0xFF);
                            socket.setSoTimeout(0);
                        } catch (Exception e) {
                            for (Iterator<Socket> iterator = sockets.iterator(); iterator.hasNext(); ) {
                                Socket value = iterator.next();
                                if (value.getInetAddress() == socket.getInetAddress()) {
                                    /*List<WcsEquipment> wcsEquipmentList = WcsEquipment.dao.find("select * from wcs_equipment");
                                    WcsEquipmentService wcsEquipmentService = (WcsEquipmentService) SpringContextUtils.getBean("wcsEquipmentServiceImpl");
                                    String messageClose = value.getInetAddress().getHostAddress();
                                    if (wcsEquipmentList != null) {
                                        for (WcsEquipment wcsEquipment : wcsEquipmentList) {
                                            if (wcsEquipment.getEquipmentIp().equals(messageClose)) {
                                                WcsEquipment wcsEquipmentEditId = new WcsEquipment();
                                                wcsEquipmentEditId.setBankPlaceNo(wcsEquipment.getBankPlaceNo());
                                                wcsEquipmentEditId.setId("0");
                                                wcsEquipmentEditId.setEquipmentStatus("00");
                                                Boolean flagId = wcsEquipmentService.update(wcsEquipmentEditId);
                                                if (flagId) {
                                                    log.info("断开连接");
                                                }
                                            }
                                        }
                                    }*/
                                    iterator.remove();
                                    log.info(sockets.toString());
                                }
                            }
                        }
                    }
                }, 5000, 1000);
                // 将已有的连接添加到集合中
                sockets.add(socket);
                // 建立读取客户端数据的线程
                Thread t = new Thread(new ReadClientDataThread(socket));
                t.start();
            }
        } catch (Exception e) {
            System.out.println("Socket运行中出现了异常：\n");
            log.error(e.getMessage());
        }
    }
}
